# underscore extensions

## Adds following variables to __window__ variable:
- ### _: which is a shortcut for import _ from 'underscore'

## Exports:
- ### __isVoid function(value) -> Boolean__: checks if the _value_ is either _null_ or _undefined_
    > isVoid(null) <br/>
    > returns: true
- ### __isJquery function(value) -> Boolean__: checks if the _value_ is an instance of _jQuery_
    > isJquery($('.test')) <br>
    > returns: true
- ### __toJquery function(value) -> jQuery__: if the _value_ is not a _jQuery instance_, assumes that _value_ is a _jquery selector_ and returns the jquery instance of that selector
    > toJquery($('.test')) <br>
    > returns: $('.test') variable <br>
    > toJquery('.test') <br>
    > returns: $('.test') variable
- ### __callSafe function(func) -> return value of func__: calls the given function if it is available
- ### __guid function() -> String__: returns a c# Guid.NewGuid().ToString("N") like string
    > guid() <br>
    > returns: 976edaa0d2464573a6ea01aabaa98899
- ### __newId function() -> String__: returns guid() plus a prefix to make it suitable for html id attributes
    > newId() <br>
    > returns: e_976edaa0d2464573a6ea01a4bca98899
- ### __kebab_case_to_camelCase function(kebabCase) -> String__: converts kebab-case string into camelCase equivalent
    > kebab_case_to_camelCase('cms7-underscore') <br>
    > returns: cms7Underscore
- ### __containsArabic function(value) -> Boolean__: checks if a string contains persian or arabic characters
- ### __isKeyAlphaNumeric function(keyCode) -> Boolean__: checks if the given _keyCode_ of a jquery's _keyup_ or _keydown_ events is either digit or letter
- ### __isKeyTextInput function(keyCode) -> Boolean__: checks if the given _keyCode_ of a jquery's _keyup_ or _keydown_ events is either digit or letter and is __NOT__ _backspace: 8_ nor _delete: 46_
- ### __spinLock class(locked: func, unlocked: func)__:
    - ### methods:
        - lock() -> void: locks the object
        - unlock() -> void: unlocks the object
        - isLocked() -> Boolean: tells if the object is locked
        - waitForLock(callback: func) -> void: invokes the _callback_ asynchronously when the object is unlocked
- ### __render function(template: String, data: Object) -> String__: renders a template using the data as its model with underscorejs template engine

## Adds the above methods to any __underscore__ variable:
for example _.isVoid, _.isJquery, ...